/* MailTweak internal component - Copyright (C) 2007, 2009 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://mailtweak.mozdev.org/ */
pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak.")
SDF = Components.classes["@mozilla.org/intl/scriptabledateformat;1"].getService(Components.interfaces.nsIScriptableDateFormat)
onload = function () {
var clock = document.getElementById("datetime")
var d = pref.getIntPref("start.date")
clock.datelong = (d < 3)
clock.dateformat = d == 3? 0 : d
clock.dateordinal = pref.getBoolPref("start.ordinal")
clock.dateweek = pref.getBoolPref("start.week")
var c = pref.getIntPref("start.clock")
clock.timeformat = c == 3? 0 : c
clock.notify(null)
clock.start()
if (c == 3 && window.SVGDocument) {
document.loadOverlay("chrome://mailtweak/content/clock.xul", {observe: function () {analog()}})
document.getElementById("time-stack").hidden = true}
document.getElementById("calendar").init()}
analog = function () {
clock = document.getElementById("analog")
seconds = document.getElementById("seconds")
minutes = document.getElementById("minutes")
hours = document.getElementById("hours")
var edge = document.getElementById("edge")
var p = Math.PI / 30
for (var i = 0; i < 60; ++i) {
var s = i * p, hour = (i % 5) == 0, w = hour? 0.875 : 0.925
with (edge.appendChild(document.createElementNS("http://www.w3.org/2000/svg", "line")))
setAttribute("class", hour? "hour" : "minute"),setAttribute("x1", Math.cos(s)),setAttribute("y1", Math.sin(s)),setAttribute("x2", w * Math.cos(s)),setAttribute("y2", w * Math.sin(s))}
tick()
setInterval(tick, 1000);}
function tick() {
var p = Math.PI / 30
with (new Date) {
var s = getSeconds(), m = getMinutes(), h = getHours()
clock.setAttribute("tooltiptext", SDF.FormatTime("", 2, h, m, 0))
s = s * p
m = m * p + s / 60
h = h * p * 5 + m / 12}
with (seconds) setAttribute("x2", 0.9 * Math.cos(s)), setAttribute("y2", 0.9 * Math.sin(s))
with (minutes) setAttribute("x2", 0.8 * Math.cos(m)), setAttribute("y2", 0.8 * Math.sin(m))
with (hours) setAttribute("x2", 0.5 * Math.cos(h)), setAttribute("y2", 0.5 * Math.sin(h))}
